452:用最少数量的箭引爆气球
This commit is contained in:
parent
abacbd5ee7
commit
c50d9417ec
@ -0,0 +1,91 @@
|
||||
//在二维空间中有许多球形的气球。对于每个气球,提供的输入是水平方向上,气球直径的开始和结束坐标。由于它是水平的,所以纵坐标并不重要,因此只要知道开始和结束的横
|
||||
//坐标就足够了。开始坐标总是小于结束坐标。
|
||||
//
|
||||
// 一支弓箭可以沿着 x 轴从不同点完全垂直地射出。在坐标 x 处射出一支箭,若有一个气球的直径的开始和结束坐标为 xstart,xend, 且满足 xsta
|
||||
//rt ≤ x ≤ xend,则该气球会被引爆。可以射出的弓箭的数量没有限制。 弓箭一旦被射出之后,可以无限地前进。我们想找到使得所有气球全部被引爆,所需的弓箭的
|
||||
//最小数量。
|
||||
//
|
||||
// 给你一个数组 points ,其中 points [i] = [xstart,xend] ,返回引爆所有气球所必须射出的最小弓箭数。
|
||||
//
|
||||
//
|
||||
// 示例 1:
|
||||
//
|
||||
//
|
||||
//输入:points = [[10,16],[2,8],[1,6],[7,12]]
|
||||
//输出:2
|
||||
//解释:对于该样例,x = 6 可以射爆 [2,8],[1,6] 两个气球,以及 x = 11 射爆另外两个气球
|
||||
//
|
||||
// 示例 2:
|
||||
//
|
||||
//
|
||||
//输入:points = [[1,2],[3,4],[5,6],[7,8]]
|
||||
//输出:4
|
||||
//
|
||||
//
|
||||
// 示例 3:
|
||||
//
|
||||
//
|
||||
//输入:points = [[1,2],[2,3],[3,4],[4,5]]
|
||||
//输出:2
|
||||
//
|
||||
//
|
||||
// 示例 4:
|
||||
//
|
||||
//
|
||||
//输入:points = [[1,2]]
|
||||
//输出:1
|
||||
//
|
||||
//
|
||||
// 示例 5:
|
||||
//
|
||||
//
|
||||
//输入:points = [[2,3],[2,3]]
|
||||
//输出:1
|
||||
//
|
||||
//
|
||||
//
|
||||
//
|
||||
// 提示:
|
||||
//
|
||||
//
|
||||
// 1 <= points.length <= 104
|
||||
// points[i].length == 2
|
||||
// -231 <= xstart < xend <= 231 - 1
|
||||
//
|
||||
// Related Topics 贪心 数组 排序
|
||||
// 👍 445 👎 0
|
||||
|
||||
package leetcode.editor.cn;
|
||||
|
||||
import java.util.Arrays;
|
||||
import java.util.Comparator;
|
||||
|
||||
//452:用最少数量的箭引爆气球
|
||||
class MinimumNumberOfArrowsToBurstBalloons{
|
||||
public static void main(String[] args) {
|
||||
//测试代码
|
||||
Solution solution = new MinimumNumberOfArrowsToBurstBalloons().new Solution();
|
||||
}
|
||||
|
||||
//力扣代码
|
||||
//leetcode submit region begin(Prohibit modification and deletion)
|
||||
class Solution {
|
||||
public int findMinArrowShots(int[][] points) {
|
||||
if (points.length == 0) {
|
||||
return 0;
|
||||
}
|
||||
Arrays.sort(points, Comparator.comparingInt(point -> point[1]));
|
||||
int num = points[0][1];
|
||||
int count = 1;
|
||||
for (int[] point: points) {
|
||||
if (point[0] > num) {
|
||||
num = point[1];
|
||||
count++;
|
||||
}
|
||||
}
|
||||
return count;
|
||||
}
|
||||
}
|
||||
//leetcode submit region end(Prohibit modification and deletion)
|
||||
|
||||
}
|
@ -0,0 +1,52 @@
|
||||
<p>在二维空间中有许多球形的气球。对于每个气球,提供的输入是水平方向上,气球直径的开始和结束坐标。由于它是水平的,所以纵坐标并不重要,因此只要知道开始和结束的横坐标就足够了。开始坐标总是小于结束坐标。</p>
|
||||
|
||||
<p>一支弓箭可以沿着 x 轴从不同点完全垂直地射出。在坐标 x 处射出一支箭,若有一个气球的直径的开始和结束坐标为 <code>x</code><sub><code>start</code>,</sub><code>x</code><sub><code>end</code>,</sub> 且满足 <code>x<sub>start</sub> ≤ x ≤ x</code><sub><code>end</code>,</sub>则该气球会被引爆<sub>。</sub>可以射出的弓箭的数量没有限制。 弓箭一旦被射出之后,可以无限地前进。我们想找到使得所有气球全部被引爆,所需的弓箭的最小数量。</p>
|
||||
|
||||
<p>给你一个数组 <code>points</code> ,其中 <code>points [i] = [x<sub>start</sub>,x<sub>end</sub>]</code> ,返回引爆所有气球所必须射出的最小弓箭数。</p>
|
||||
|
||||
|
||||
<p><strong>示例 1:</strong></p>
|
||||
|
||||
<pre>
|
||||
<strong>输入:</strong>points = [[10,16],[2,8],[1,6],[7,12]]
|
||||
<strong>输出:</strong>2
|
||||
<strong>解释:</strong>对于该样例,x = 6 可以射爆 [2,8],[1,6] 两个气球,以及 x = 11 射爆另外两个气球</pre>
|
||||
|
||||
<p><strong>示例 2:</strong></p>
|
||||
|
||||
<pre>
|
||||
<strong>输入:</strong>points = [[1,2],[3,4],[5,6],[7,8]]
|
||||
<strong>输出:</strong>4
|
||||
</pre>
|
||||
|
||||
<p><strong>示例 3:</strong></p>
|
||||
|
||||
<pre>
|
||||
<strong>输入:</strong>points = [[1,2],[2,3],[3,4],[4,5]]
|
||||
<strong>输出:</strong>2
|
||||
</pre>
|
||||
|
||||
<p><strong>示例 4:</strong></p>
|
||||
|
||||
<pre>
|
||||
<strong>输入:</strong>points = [[1,2]]
|
||||
<strong>输出:</strong>1
|
||||
</pre>
|
||||
|
||||
<p><strong>示例 5:</strong></p>
|
||||
|
||||
<pre>
|
||||
<strong>输入:</strong>points = [[2,3],[2,3]]
|
||||
<strong>输出:</strong>1
|
||||
</pre>
|
||||
|
||||
<p> </p>
|
||||
|
||||
<p><strong>提示:</strong></p>
|
||||
|
||||
<ul>
|
||||
<li><code>1 <= points.length <= 10<sup>4</sup></code></li>
|
||||
<li><code>points[i].length == 2</code></li>
|
||||
<li><code>-2<sup>31</sup> <= x<sub>start</sub> < x<sub>end</sub> <= 2<sup>31</sup> - 1</code></li>
|
||||
</ul>
|
||||
<div><div>Related Topics</div><div><li>贪心</li><li>数组</li><li>排序</li></div></div>\n<div><li>👍 445</li><li>👎 0</li></div>
|
Loading…
Reference in New Issue
Block a user